//Codeusa Software Shaders

#define FXAA_QUALITY__PRESET 9
#define USE_ANTI_ALIASING
#define USE_PRE_SHARPEN
#define USE_TONEMAP
#define USE_VIGNETTE
#define USE_POST_SHARPEN

//FXAA inactive; base routine running since other shaders depend on it; build in PAYDAY used for actual anti-aliasing.
float fxaaQualitySubpix = 0;
float fxaaQualityEdgeThreshold = 0;
float fxaaQualityEdgeThresholdMin = 0;


//PRE-SHARPENING: sharpeness the image to balance out the fuzzy blur caused by ingame FXAA
bool highQualitySharpen = 1;
#define Average 0.20
#define CoefBlur 4
#define SharpenEdge 0.80
#define Sharpen_val0 0.60


//TONEMAP: Completely post processes the colours for more natural contrast and saturation (leave PAYDAY config gamma at default, use gamma below to adjust for your monitor 
#define Gamma 1.00             // higher values give a darker and more saturated colour band
#define Exposure 0.00         // simulates exposure: higher values dramatically increase strength of bright parts of the image, used here to balance the overall loss of gamma brightness and to increase the overall contrast
#define Saturation 0.20      // strength of the colour band, lowered here to balance the excessive saturation caused by high gamma whilst retaining high and natural contrast
#define BlueShift 0.00 
#define Bleach 0.00 
#define Defog 0.00 
#define FogColor float4(0.0, 0.0, 0.1, 0.2) 


//VIGNETTE: Very subtly darkeness the images close to monitor edges, effect often used in film to concentrate the imgage and "force" the frame
//#define VignetteCenter float2(0.500, 0.500) 
//#define VignetteRadius 100.0 
//#define VignetteAmount -0.01
#define VignetteCenter float2(0.500, 0.500) 
#define VignetteRadius 100.0 
#define VignetteAmount -0.01
//POST-SCHARPENING: final sharpening pass to smooth out the finished frame and retain and overall crisp image
float Sharpen = .060;